#include <Lightflow/LfLocalSceneProxy.h>
#include "tree.h"
#include <math.h>

int main()
{
    LfLocalSceneProxy *s = new LfLocalSceneProxy();
    LfArgList list;

    list.Reset();
    list << "position" << LfPoint(-3,2,5);
    list << "color" << LfColor(300.0,300.0,300.0);
    s->LightOn(s->NewLight("point",list));

    list.Reset();
    list << "kr" << LfVector3(0.6,0.3,0.3);
    list << "kd" << 0.3;
    list << "km" << 0.3;
    list << "shinyness" << 0.8;
    list << "fresnel" << LfInt(1) << LfFloat(0.5) << LfFloat(0.5);
    list << "caustics" << LfInt(1) << LfInt(1);
    LfInt metal = s->NewMaterial("physical",list);
    
    list.Reset();
    LfInt bump = s->NewPattern("granite",list);
    
    list.Reset();
    list << "kr" << LfVector3(0.6,0.3,0.3);
    list << "kd" << 0.3;
    list << "km" << 0.3;
    list << "shinyness" << 0.8;
    list << "fresnel" << LfInt(1) << LfFloat(0.5) << LfFloat(0.5);
    list << "caustics" << LfInt(1) << LfInt(1);
    list << "displacement" << bump;
    LfInt bumpmetal = s->NewMaterial("physical",list);

    s->MaterialBegin(bumpmetal);
    list.Reset();
    list << "radius" << 20.0;
    s->AddObject(s->NewObject("disc",list));
    s->MaterialEnd();

    s->MaterialBegin(metal);
    {
	tree(s,2,45*M_PI/180.0,0.5,8);
    }
    s->MaterialEnd();
    
    list.Reset();
    list << "file" << "tree.tga";
    LfInt saver = s->NewImager("tga-saver",list);
    s->ImagerBegin(saver);
	list.Reset();
	list << "eye" << LfPoint(2,-3,6);
	list << "aim" << LfPoint(0,0,2);
	LfInt camera = s->NewCamera("pinhole",list);
    s->ImagerEnd();

    s->Radiosity();

    s->Render(camera,640,480);

    if(s) delete s;

    return 0;
}
